# do not import all endpoints into this module because that uses a lot of memory and stack frames
# if you need the ability to import all endpoints from this module, import them with
# from snaptrade_client.apis.path_to_api import path_to_api

import enum


class PathValues(str, enum.Enum):
    _ = "/"
    _SNAP_TRADE_ACCEPT_DISCLAIMER = "/snapTrade/acceptDisclaimer"
    _SNAP_TRADE_LIST_USERS = "/snapTrade/listUsers"
    _SNAP_TRADE_REGISTER_USER = "/snapTrade/registerUser"
    _SNAP_TRADE_DELETE_USER = "/snapTrade/deleteUser"
    _SNAP_TRADE_LOGIN = "/snapTrade/login"
    _SNAP_TRADE_ENCRYPTED_JWT = "/snapTrade/encryptedJWT"
    _SNAP_TRADE_PARTNERS = "/snapTrade/partners"
    _HOLDINGS = "/holdings"
    _ACCOUNTS_ACCOUNT_ID_HOLDINGS = "/accounts/{accountId}/holdings"
    _ACCOUNTS = "/accounts"
    _ACCOUNTS_ACCOUNT_ID = "/accounts/{accountId}"
    _ACCOUNTS_ACCOUNT_ID_BALANCES = "/accounts/{accountId}/balances"
    _ACCOUNTS_ACCOUNT_ID_POSITIONS = "/accounts/{accountId}/positions"
    _ACCOUNTS_ACCOUNT_ID_ORDERS = "/accounts/{accountId}/orders"
    _ACCOUNTS_ACCOUNT_ID_QUOTES = "/accounts/{accountId}/quotes"
    _ACCOUNTS_ACCOUNT_ID_ORDERS_CANCEL = "/accounts/{accountId}/orders/cancel"
    _ACCOUNTS_ACCOUNT_ID_SYMBOLS = "/accounts/{accountId}/symbols"
    _ACCOUNTS_ACCOUNT_ID_OPTIONS = "/accounts/{accountId}/options"
    _ACCOUNTS_ACCOUNT_ID_OPTIONS_CHAIN = "/accounts/{accountId}/optionsChain"
    _ACCOUNTS_ACCOUNT_ID_OPTION_STRATEGY = "/accounts/{accountId}/optionStrategy"
    _ACCOUNTS_ACCOUNT_ID_OPTION_STRATEGY_OPTION_STRATEGY_ID = "/accounts/{accountId}/optionStrategy/{optionStrategyId}"
    _ACCOUNTS_ACCOUNT_ID_OPTION_STRATEGY_OPTION_STRATEGY_ID_EXECUTE = "/accounts/{accountId}/optionStrategy/{optionStrategyId}/execute"
    _AUTHORIZATIONS = "/authorizations"
    _AUTHORIZATIONS_AUTHORIZATION_ID = "/authorizations/{authorizationId}"
    _SESSION_EVENTS = "/sessionEvents"
    _BROKERAGES = "/brokerages"
    _BROKERAGE_AUTHORIZATION_TYPES = "/brokerageAuthorizationTypes"
    _CURRENCIES = "/currencies"
    _SNAP_TRADE_LIST_USER_ERRORS = "/snapTrade/listUserErrors"
    _CURRENCIES_RATES = "/currencies/rates"
    _CURRENCIES_RATES_CURRENCY_PAIR = "/currencies/rates/{currencyPair}"
    _EXCHANGES = "/exchanges"
    _SECURITY_TYPES = "/securityTypes"
    _MODEL_ASSET_CLASS = "/modelAssetClass"
    _MODEL_ASSET_CLASS_MODEL_ASSET_CLASS_ID = "/modelAssetClass/{modelAssetClassId}"
    _MODEL_PORTFOLIO = "/modelPortfolio"
    _MODEL_PORTFOLIO_MODEL_PORTFOLIO_ID = "/modelPortfolio/{modelPortfolioId}"
    _PORTFOLIO_GROUPS = "/portfolioGroups"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID = "/portfolioGroups/{portfolioGroupId}"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_ACCOUNTS = "/portfolioGroups/{portfolioGroupId}/accounts"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_BALANCES = "/portfolioGroups/{portfolioGroupId}/balances"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_CALCULATEDTRADES = "/portfolioGroups/{portfolioGroupId}/calculatedtrades"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_CALCULATEDTRADES_CALCULATED_TRADE_ID_TRADE_ID = "/portfolioGroups/{portfolioGroupId}/calculatedtrades/{calculatedTradeId}/{TradeId}"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_CALCULATEDTRADES_CALCULATED_TRADE_ID_IMPACT = "/portfolioGroups/{portfolioGroupId}/calculatedtrades/{calculatedTradeId}/impact"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_CALCULATEDTRADES_CALCULATED_TRADE_ID_MODIFY_TRADE_ID = "/portfolioGroups/{portfolioGroupId}/calculatedtrades/{calculatedTradeId}/modify/{tradeId}"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_CALCULATEDTRADES_CALCULATED_TRADE_ID_PLACE_ORDERS = "/portfolioGroups/{portfolioGroupId}/calculatedtrades/{calculatedTradeId}/placeOrders"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_EXCLUDEDASSETS = "/portfolioGroups/{portfolioGroupId}/excludedassets"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_EXCLUDEDASSETS_SYMBOL_ID = "/portfolioGroups/{portfolioGroupId}/excludedassets/{symbolId}"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_IMPORT = "/portfolioGroups/{portfolioGroupId}/import"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_INFO = "/portfolioGroups/{portfolioGroupId}/info"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_POSITIONS = "/portfolioGroups/{portfolioGroupId}/positions"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_SETTINGS = "/portfolioGroups/{portfolioGroupId}/settings"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_SYMBOLS = "/portfolioGroups/{portfolioGroupId}/symbols"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_TARGETS = "/portfolioGroups/{portfolioGroupId}/targets"
    _PORTFOLIO_GROUPS_PORTFOLIO_GROUP_ID_TARGETS_TARGET_ASSET_ID = "/portfolioGroups/{portfolioGroupId}/targets/{targetAssetId}"
    _SYMBOLS = "/symbols"
    _SYMBOLS_TICKER = "/symbols/{ticker}"
    _TRADE_PLACE = "/trade/place"
    _TRADE_IMPACT = "/trade/impact"
    _TRADE_TRADE_ID = "/trade/{tradeId}"
    _TRADE_OCO = "/trade/oco"
    _ACTIVITIES = "/activities"
    _PERFORMANCE_CUSTOM = "/performance/custom"
